import React from 'react'
import universal from 'react-universal-component'
import styled from 'styled-components'

const UniversalComponent = universal(({ page }) => import(`./${page}`))

const NavButton = styled.button`
  padding: 0.5rem;
  margin-right: 0.5rem;
  background: none;
  border: 1px solid black;
  cursor: pointer;
  &:focus {
    outline: 0;
  }
`

export default class App extends React.Component {
  render () {
    const { error, page } = this.state

    return (
      <div>
        <h1>React Redux SSR</h1>
        {error && <div>{error.toString()}</div>}

        <UniversalComponent
          page={page}
          onBefore={this.beforeChange}
          onAfter={this.afterChange}
          onError={this.handleError}
        />

        <NavButton onClick={() => this.setPage('first')}>First</NavButton>
        <NavButton onClick={() => this.setPage('second')}>Second</NavButton>
      </div>
    )
  }

  constructor (props) {
    super(props)

    this.state = {
      error: null,
      page: 'first'
    }
  }

  setPage = page => {
    this.setState({ page })
  }

  handleError = error => {
    this.setState({ error })
  }
}
