import React from 'react'
import ReactDOM from 'react-dom'
import AppContainer from 'react-hot-loader/lib/AppContainer'
import App from './components/app'

const render = App =>
  ReactDOM.hydrate(
    <AppContainer>
      <App />
    </AppContainer>,
    document.getElementById('root')
  )

if (process.env.NODE_ENV === 'development' && module.hot) {
  module.hot.accept('./components/app.js', () => {
    const App = require('./components/app').default
    render(App)
  })
}

render(App)
