import React from 'react'
import { renderToString } from 'react-dom/server'
import { ServerStyleSheet } from 'styled-components'
import { flushChunkNames } from 'react-universal-component/server'
import flushChunks from 'webpack-flush-chunks'
import App from './components/app'

export default ({ clientStats }) => (req, res) => {
  const sheet = new ServerStyleSheet()
  const app = renderToString(sheet.collectStyles(<App />))

  const chunkNames = flushChunkNames()
  const { js } = flushChunks(clientStats, { chunkNames })

  res.send(
    `<!doctype html>
      <html>
        <head>
          <meta charset="utf-8">
          <title>react-universal-component-boilerplate</title>
          ${sheet.getStyleTags()}
        </head>
        <body>
          <div id="root">${app}</div>
          ${js}
        </body>
      </html>`
  )
}
