const { resolve } = require('path')
const { DefinePlugin, optimize: { LimitChunkCountPlugin } } = require('webpack')

module.exports = {
  name: 'server',
  target: 'node',
  devtool: 'source-map',
  entry: [resolve(__dirname, '../src/server.js')],
  output: {
    path: resolve(__dirname, '../dist/serverFrontend'),
    filename: '[name].js',
    libraryTarget: 'commonjs2'
  },
  module: {
    rules: [
      {
        test: /\.jsx?$/,
        exclude: /node_modules/,
        use: 'babel-loader'
      }
    ]
  },
  resolve: {
    extensions: ['.js', '.jsx']
  },
  plugins: [
    new LimitChunkCountPlugin({
      maxChunks: 1
    }),
    new DefinePlugin({
      'process.env': {
        NODE_ENV: JSON.stringify('production')
      }
    })
  ]
}
